/*********************************************/
/*    Metagraphics Software Corporation      */
/*        Copyright (c) 1987-1993            */
/*********************************************/
/* FILE:    guiextrn.h                       */
/* PURPOSE: module contains C function       */
/*          prototypes                       */
/*********************************************/
/*  %kw # %v    %n    %d    %t # */
/* Version # 3    GUIEXTRN.H    10-Jun-93    15:04:02 # */

#ifdef __cplusplus      /* If C++, disable "mangling" */
extern "C" {
#endif

/* In Application */
void SEQ Init          (int argc, char *argv[]);
void SEQ Close         (void); 
void SEQ ProcessMenu   (void);
void SEQ IdleProcess   (void);

/* GUIDILG */
void SEQ InitDialog    (void);
int  SEQ Dialog        (int, char *, char *);
void SEQ ShowDialog    (int, dialogBox *);
void SEQ HideDialog    (int, dialogBox *);
void SEQ OpenWindow    ( dialogBox * );
void SEQ CloseWindow   ( dialogBox * );
void SEQ DrawButton    (rect *, char * );
void SEQ DialogButton  (rect *, int );
void SEQ OnButton      ( rect * );
void SEQ Button3D      ( rect * );
int  SEQ DialogText    (int, dialogBox *, char * ); 
void SEQ DilgShowText  ( rect *, char * );
void SEQ DrawScrollBar ( scrollBar * );
void SEQ PositionSB    ( scrollBar * );  
void SEQ DoScrollBar   ( scrollBar * );

/* GUIFILE */
int  SEQ FileDialog    ( char *filespec );

/* GUIINIT */
void SEQ InitGUI       (void);

/* GUIMAIN */
void SEQ main         (void);
void SEQ abend        (int, char *);
int  SEQ CriticalError (int, int );

/* GUIMOTF */
void SEQ InitMenu      (void);
int  SEQ CheckIfMenu   (void);
void SEQ WaitMenuSelect(void);

/* GUIFORM */
void SEQ DrawForm      (dialogBox *, formEntry *, int );
int  SEQ DoForm        (dialogBox *, formEntry *, int );
void SEQ DrawBallot    ( formEntry * );
void SEQ OnBallot      ( formEntry *, int );
int  SEQ DoBallot      ( formEntry * );
int  SEQ FormText      ( dialogBox *, formEntry *, int);

/* GUIVIEW */
void SEQ ViewFile      ( char *fileName, char *wname );
void SEQ ViewBuffer    ( char *buf, char *wname );
char* SEQ ViewItemList ( char *buf, char *wname );
int  SEQ GUIWindow     ( dialogBox *dia, char *name );
int  SEQ CheckClose    ( dialogBox *dia );
void SEQ DrawView      ( char *name );

/* GUIUTIL */
//void SEQ delay         (unsigned int);
void SEQ DoBeep        (void);
int  SEQ picX          (int);
int  SEQ picY          (int);
int  SEQ equX          (int);
int  SEQ equY          (int);
void SEQ ShadowRect    (rect *, int);
void SEQ OnBevel       (rect *);
void SEQ OffBevel      (rect *);
void SEQ FlushEvents   (void);
char* SEQ DosError     (int);
void SEQ RegenDesk     (void);

#ifdef __cplusplus
}
#endif

/* End of File  -  GUIEXTRN.H */

