#include <fstream.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <bios.h>
#include <alloc.h>
#define GUIMAIN

#include "metawndo.h"
#include "GUIconst.h"
#include "GUIextrn.h"

#define PAPEROUT  0x20
#define SELECTED  0x10

#ifdef      TurboC
extern unsigned _stklen = 14336U;  /* stack size 14K */
#endif
extern rect *scrnRect;
extern int mainstart;
int PgmAbort ( char *msg );
int PrinterPort;
void AboutInit( void);
   int meta_hd_size;

void IdleProcess(void)
{
   unsigned long avail;
  static long oldavail;

char mess[255];
	avail=(unsigned long)	coreleft();
	if(avail!=oldavail){
	     TextAlign( alignRight, alignBaseline );

	sprintf(mess, "Memory Left= %lu", avail);
  MoveTo(scrnRect->Xmax-75,scrnRect->Ymax-25);
 DrawString(mess);
 oldavail=avail;
 }
	if(avail<=0xFFFF){
	 TextAlign( alignCenter, alignBaseline );

	sprintf(mess, "Warning! Memory Low Please Exit Program and Restart ");
  MoveTo(scrnRect->Xmax/2,scrnRect->Ymax/2);
 DrawString(mess);

 }


}
void main( void )
{
       int i;

	meta_hd_size=(sizeof(imageHeader))+1;

     InitGUI();


    InitMenu();
   InitDialog();
   mainstart=1;
   AboutInit();
    /* main event loop */
   do {  /* until exit selected */

      opSelect.selectID = nullSelect;

      do {  /* until something selected */

	 /* wait for an event */
	 while( !KeyEvent( False,&opEvent ) )
	   IdleProcess();

	 /* act on event */
	 switch( opEvent.eventType ) {

            case evntPRESS:

               /* check if press event was in Menu Bar */
	       /* might end up selecting something    */
	       CheckIfMenu();
               break;
            
            case evntKEYDN:

	       /* control C selects an exit */
	       if( opEvent.eventChar == 03 ) {
		  opSelect.selectID = exitSelect;
		  break;
               }

		    /* check if Menu Bar key */
		    /* might end up selecting something    */
		    if( !CheckIfMenu() ) {
		  /* wasn't menu key, pass on as a key selection */
		  opSelect.selectID = keySelect;
                  opSelect.selChar = opEvent.eventChar;
               }

	       break;

            default:
               break;

         }   /* end of switch */

      } while( opSelect.selectID == nullSelect );

      /* ok, operator selected something */
      switch ( opSelect.selectID ) {

	 case menuSelect:
	    ProcessMenu();
	    break;

         case exitSelect:
            Close();
            break;

	 case keySelect:
            break;
      }

   } while( opSelect.selectID != exitSelect );


   /* clean up and exit */
   StopMouse();
   StopEvent();
   SetDisplay( TextPg0 );
   StopGraphics();

}

void abend( int errnbr, char *errmsg)
/*
Clean up and print an error message and error number, then exit 
*/
{
   int i;
   char *s;

   StopMouse();
   StopEvent();
   SetDisplay(TextPg0); 
   StopGraphics();

   printf("\n\nAbormal End Error #%d\n", abs(errnbr) );

   s = "\0";
   switch( errnbr ) {

      case ER_NODRVR:
	 s = " Driver error!";
	 break;
      case ER_MEM:
         s = "Not Enough Memory!";
         break;
      case ER_LOAD:
	 s = "Unable to load file";
	 break;
   }
    if( errmsg == NULL )
      errmsg = "";

   printf("%s %s\n", s, errmsg );
   if(errnbr==ER_NODRVR) printf("\n\n  Run the program setup to choose another video display mode.\n\n");
   i = QueryError();
   printf("    QueryError = %d/%d\n\n", i >> 7, i & 127 );
   if(errnbr==ER_MEM)system("mem");
   exit( 8 );

}

 int checkprinter(void)
 {
   unsigned status;
   int err=1;

	    status=_bios_printer(2,PrinterPort,0);
	    if ((status & PAPEROUT) != 0){err= PgmAbort("Out of Paper");
	    return(err);}
	    if ((status & SELECTED) == 0){err= PgmAbort("Printer not online");
	    return(err);}
     return(err);
}


int PgmAbort(char *msg)
/* Global error handler */
{

   Dialog( diaAlert, "Problem printing file:", msg );
   return (0);
}


/* End of File  -  GUIMAIN.C */


