/*********************************************/
/*    Metagraphics Software Corporation      */
/*        Copyright (c) 1987-1993            */
/*********************************************/
/* FILE:    guiview.c                        */
/* PURPOSE: contains view window support     */
/*********************************************/
/*  %kw # %v    %n    %d    %t #             */
/* Version # 1    GUIVIEW.C    11-Jun-93    14:25:44 # */
#include <fstream.h>
#include <strstream.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "metawndo.h"
#include "guiconst.h"
#include "guiextrn.h"
#include <io.h>
#include <sys\stat.h>
#include <fcntl.h>

int bar_doc,view_cut;
int savewindow;
void DoView( void );
void ScrollView( int );
void DrawTextLine( int linenum, int linecnt );
void DrawItemList( char *name );
int  DoItemList( void );
int  CheckItemList( rect *itemR, int x, int y );


void ViewFile( char *fileName, char *wname )
/*
View a text file in 32 bit protected mode
*/
{

   char *buf;
   FILE *fp;

   int handle=open(fileName,O_RDONLY | O_TEXT);
   long x=0;
   x=filelength(handle);
   close(handle);

   fp = fopen( fileName, "rt" );
   if( fp == NULL ) {
      Dialog( diaAlert, "Can't open file:", fileName );
      return;
   }


      buf = (char *)malloc( x+10 );

   if( buf == NULL ) {
      Dialog( diaAlert, "Not enough memory!", NULL );
      return;
   }

     int c,i=0;
	while( (c = fgetc( fp )) != EOF ){
	buf[i]=(char)c;
	i++;
	}

      fclose( fp );


   ViewBuffer( buf, wname );
      memset(buf, NULL, sizeof(buf));

     free( buf );

   return;

}

char * ViewList( char *fileName, char *wname )
/*
View a text file in a scrollable view window
*/
{


   char s[80],*p;
   fstream f1;
   strstream txt;

   f1.open( fileName,ios::in);
   if( !f1 ) {
      Dialog( diaAlert, "Can't open file:", fileName );
      return 0;
   }

      while(f1){
      f1.getline(s,sizeof(s));
      txt << s << '\0';

      }
     txt << ends;
     f1.close();
  p=ViewItemList( txt.str(), wname );

   txt.rdbuf()->freeze(0);
   return p;


}


void ViewBuffer( char *buffer, char *wname )
/*
View a text buffer in a scrollable view window
*/
{
   char *p;
   int i;
   fontRcd *userfnt;

   viewBuf = buffer;

   /* switch to system font while drawing view box */
   userfnt = scrnPort->txFont;
   SetFont( sysFont );
   DrawView( wname );
   SetFont( userfnt );

   /* count lines of text */
   p = viewBuf;
   i = 0;
   while( True ) {

      if( *p == 0 || *p == '\n' ) {
         i++;  /* count line */
         p++;  /* skip null */
	 if( *p == 0 ) /* double null ? */
	    break;
	 if( *p == '@' ) /* double null ? */
	    break;

      } else
	 p++;

   }

   /* set scroll bar limit to number of text lines (0..n) */
   viewSBar.maxval = i - 10;

   /* process events */
   DoView();

   /* close window */
// CloseWindow( &viewDlgBox );

   if(bar_doc!=True)RegenDesk();

}


void DrawView( char *name )
/*
Draw a view window;
A view window is a GUI window with scroll bar
*/
{
   int a,b,c,line;
   grafPort *wPort;
   
   line = scrnPort->txFont->lnSpacing;

   /* size a bounding box */
   DupRect( &scrnPort->portRect, &viewDlgBox.BoundRect );
   if(bar_doc==True)SetRect( &viewDlgBox.BoundRect, picX( 100 ),scrnPort->portRect.Ymin+ picY(150),scrnPort->portRect.Xmax-picX(100),scrnPort->portRect.Ymax-picY(50) );
   else InsetRect( &viewDlgBox.BoundRect, picX( 75 ), picY(100) );

   GUIWindow( &viewDlgBox, name );

   /* chuck the window port - we'll just be global */
   GetPort( &wPort );
   SetPort( scrnPort );
   free( wPort );

   ProtectRect( &viewDlgBox.BoundRect );


   /* frame text window  */
   DupRect( &viewDlgBox.BoundRect, &viewDlgBox.BoxR );
   viewDlgBox.BoxR.Xmin += picX(25);
   viewDlgBox.BoxR.Xmax -= picX(50);
   viewDlgBox.BoxR.Ymin += picY(50);
   a = viewDlgBox.BoxR.Ymin;
   b = viewDlgBox.BoxR.Ymax - picY(25);
   c = (b - a) / line;
   b = (c * line) + a + 3;
   viewDlgBox.BoxR.Ymax  =  b;
   FrameRect( &viewDlgBox.BoxR );

   /* set up scroll bar */
   DupRect( &viewDlgBox.BoxR, &viewSBar.SBRect );
   viewSBar.SBRect.Xmin = viewSBar.SBRect.Xmax + 1;
   viewSBar.SBRect.Xmax += picX( 25 );

   /* work in interior of BoxR */
   InsetRect( &viewDlgBox.BoxR, 1, 1 );

   viewSBar.sbfunc = ScrollView;
   viewSBar.minval = 0;
   viewSBar.curval = 0;
   viewSBar.maxval = 100;
   DrawScrollBar( &viewSBar );


   ProtectRect( NULL );


}


void DoView( )
/*
View until close box pressed.
*/
{
   int x, y;

    /* place the starting page in the box */
    ScrollView( position );


    while( True ) {

      KeyEvent( True, &opEvent);

      /* check close box button or keypress  */
      if( CheckClose( &viewDlgBox ) )
         break;


      /* handle keyboard arrow keys */
      if( opEvent.eventChar == 0 || opEvent.eventChar == 0xE0 ) {


         /* up */
         if( opEvent.eventScan == 72 ) {
            opEvent.eventType = evntRELEASE;
            opEvent.eventX = viewSBar.upbox.Xmin;
	    opEvent.eventY = viewSBar.upbox.Ymin;
            /* store a companion mouse up event */
            StoreEvent( &opEvent );
	    /* make current event into a press event */
            opEvent.eventType = evntPRESS;
	 }

	 /* down */
         if( opEvent.eventScan == 80 ) {
	    opEvent.eventType = evntRELEASE;
	    opEvent.eventX = viewSBar.dnbox.Xmin;
            opEvent.eventY = viewSBar.dnbox.Ymin;
            /* store a companion mouse up event */
	    StoreEvent( &opEvent );
	    /* make current event into a press event */
	    opEvent.eventType = evntPRESS;
         }

      }

      if( opEvent.eventType != evntPRESS )
         continue;

      x = opEvent.eventX;
      y = opEvent.eventY;

      /* check scroll bar */
      if( XYInRect( x, y, &viewSBar.SBRect ) )
	 DoScrollBar( &viewSBar );

   }   /* end of while True */

}



void ScrollView( int code )
/*
Scroll a view window
*/
{

   int i, x, y;
   int pageworth, line;
   rect tR, eofbox;


   line = scrnPort->txFont->lnSpacing;
   pageworth = (viewDlgBox.BoxR.Ymax - viewDlgBox.BoxR.Ymin) / line;
   
   /* starting text position in box */
   x = viewDlgBox.BoxR.Xmin + 1;
   y = viewDlgBox.BoxR.Ymin + line;

   x = (x+7) & 0xFFF8;

   DupRect( &viewDlgBox.BoxR, &tR );

   /* adjust curval by correct amount */
   switch( code ) {

      case up:
	 if( viewSBar.curval > viewSBar.minval )
            viewSBar.curval--;
         else
            return;
	 break;

      case down:
         if( viewSBar.curval < viewSBar.maxval )
	    viewSBar.curval++;
         else
            return;
         break;

      case pgup:
	 viewSBar.curval -= pageworth - 1;
         if( viewSBar.curval < viewSBar.minval )
            viewSBar.curval = viewSBar.minval;
	 break;

      case pgdown:
         viewSBar.curval += pageworth - 1;
         if( viewSBar.curval > viewSBar.maxval )
            viewSBar.curval = viewSBar.maxval;
	 break;

      case position:
         break;

      default:
         break;

   }   /* end of switch */


   /* re draw the box */
   ProtectRect( &viewDlgBox.BoxR );
   ClipRect( &tR );

   BackColor( White );

   PenColor( colors->text );
   RasterOp( zREPz );
   TextAlign( alignLeft, alignBottom );
   TextFace( cProportional );

   switch( code ) {

      case down:
	 ScrollRect( &tR, 0, -line );
         i = pageworth - 1;
         MoveTo( x, y + i * line );
         DrawTextLine( viewSBar.curval + i, 1 );
	 break;

      case up:
	 ScrollRect( &tR, 0, line );
         MoveTo( x, y );
	 DrawTextLine( viewSBar.curval, 1 );
         break;

      default:
	 /* re-draw whole thing */
         i = viewSBar.curval;
         MoveTo( x, y );
         DrawTextLine( i, pageworth );
	 break;

   }   /* end of switch */

   /* fill eof part of display */
   if ( (viewSBar.curval + pageworth) > viewSBar.maxval ) {
      DupRect( &viewDlgBox.BoxR, &eofbox );
      i = viewSBar.maxval - viewSBar.curval;
      eofbox.Ymin = y + line*i + line/2;
      if ( eofbox.Ymax > eofbox.Ymin )
          EraseRect( &eofbox );
	  eofbox.Ymax = eofbox.Ymin;
          eofbox.Ymin -= (line/2)-1;
          EraseRect( &eofbox );
    }

    ClipRect( &scrnPort->portRect );
    ProtectRect( NULL );


}


void DrawTextLine( int linenum, int linecnt )
{
   int i;
   int x,y;
   char *p, *t;
   int lineHeight;
   rect eR;


   /* check that it's not out of bounds */
   if( linenum > viewSBar.maxval )
      return;

   QueryPosn( &x, &y );
   lineHeight = scrnPort->txFont->lnSpacing;

   /* check that the count is not out of bounds */
   if( (linenum + linecnt) > (viewSBar.maxval + 1) )
      linecnt = (viewSBar.maxval - linenum) + 1;

   /* find line in question */
   p = viewBuf;
   for( i = 0; i < linenum; i++ ) {

      while( *p && *p != '\n' )
	 p++;

      p++;
   }


   /* draw the lines */
   PenColor( colors->text );
   for( i = 0; i < linecnt; i++ ) {

      MoveTo( x, y );

      /* find the end of the line in buffer */
      t = p;
      while( *p && *p != '\n' )
	 p++;
         
      /* draw the string */
      if( *p == '\n' ) {
	 *p = 0;
	 DrawString( t );
	 *p = '\n';
      } else
         DrawString( t );

      /* erase from end of string to end of text window */
      SetRect( &eR, scrnPort->pnLoc.X, (y-lineHeight)+1,
                    scrnPort->portRect.Xmax, y+1 );
      EraseRect( &eR );

      p++;

      y += lineHeight;

   }
   
}

char * ViewItemList( char *buffer, char *wname )
/*
View a text buffer in a scrollable view window
Returns pointer to selected string in buffer or NULL if none.
*/
{
   char *p;
   int i, selection;
   

   viewBuf = buffer;


   DrawItemList( wname );

   /* count lines of text */
   p = viewBuf;
   i = 0;
   while( *p ) {

      if( *++p == 0 ) {
         i++;    /* count line */
	 p++;    /* skip null */
      }

   }

   /* set scroll bar limit to number of text lines (0..n) */
   viewSBar.maxval = i - 1;

   /* process events */
   selection = DoItemList();

   /* close window */
// CloseWindow( &viewDlgBox );
  if(view_cut!=True) RegenDesk();

   /* find selected string if any */

   if( selection < 0 )
      return NULL;

   p = viewBuf;

   if( selection > 0 ) {

      i = 0;
      while( *p ) {

	 if( *++p == 0 ) {
            i++;    /* count line */
            p++;    /* skip null */
	    if( i == selection )
               break;
	 }
      }
   }

   return p;


}


void DrawItemList( char *name )
/*
Draw an item list window, which is a modified view window;
it also contains an OK button. 
*/
{
   int a,b,c,line;
   grafPort *wPort;
   
   line = scrnPort->txFont->lnSpacing;

   /* size a bounding box */
   DupRect( &scrnPort->portRect, &viewDlgBox.BoundRect );
   if(bar_doc==True)InsetRect( &viewDlgBox.BoundRect, picX( 75 ), picY(200) );
   else InsetRect( &viewDlgBox.BoundRect, picX( 200 ), picY(200) );

   GUIWindow( &viewDlgBox, name );

   /* chuck the window port - we'll just be global */
   GetPort( &wPort );
   SetPort( scrnPort );
   free( wPort );

   ProtectRect( &viewDlgBox.BoundRect );


   /* frame text window  */
   DupRect( &viewDlgBox.BoundRect, &viewDlgBox.BoxR );
   viewDlgBox.BoxR.Xmin += picX(25);
   viewDlgBox.BoxR.Xmax -= picX(50);
   viewDlgBox.BoxR.Ymin += picY(50);
   a = viewDlgBox.BoxR.Ymin;
   b = viewDlgBox.BoxR.Ymax - picY(75);
   c = (b - a) / line;
   viewDlgBox.BoxR.Ymax  =  (c * line) + a + 3;
   FrameRect( &viewDlgBox.BoxR );

   /* set up scroll bar */
   DupRect( &viewDlgBox.BoxR, &viewSBar.SBRect );
   viewSBar.SBRect.Xmin = viewSBar.SBRect.Xmax + 1;
   viewSBar.SBRect.Xmax += picX( 25 );

   /* work in interior of BoxR */
   InsetRect( &viewDlgBox.BoxR, 1, 1 );

   viewSBar.sbfunc = ScrollView;
   viewSBar.minval = 0;
   viewSBar.curval = 0;
   viewSBar.maxval = 100;
   DrawScrollBar( &viewSBar );


   /* place OK button */
   SetRect(&viewDlgBox.OkR,
            viewDlgBox.BoxR.Xmin,
            viewDlgBox.BoundRect.Ymax - picY(65),
            viewDlgBox.BoxR.Xmin + picX(150),
            viewDlgBox.BoundRect.Ymax - picY(30) );

   DrawButton( &viewDlgBox.OkR, "Ok" );

   /* place CanR button */
   SetRect(&viewDlgBox.CanR,
	    viewDlgBox.BoxR.Xmax,
            viewDlgBox.BoundRect.Ymax - picY(65),
	    viewDlgBox.BoxR.Xmax - picX(150),
            viewDlgBox.BoundRect.Ymax - picY(30) );

   DrawButton( &viewDlgBox.CanR, "Cancel" );

   ProtectRect( NULL );


}


int DoItemList( )
/*
View until close box pressed, or OK pressed.
Allow items to be selected with the mouse.
Returns index of selected item or -1 if none.
*/
{
   int x, y, i, selectedItem;
   rect hiliteR;
   unsigned int clickTime;

   /* place the starting page in the box */
   ScrollView( position );

   /* start off with no item highlighted */
    hiliteR.Xmin =  -1;
   
   /* start off with first item selected (highlighted) */
   x = viewDlgBox.BoxR.Xmin;
   y = viewDlgBox.BoxR.Ymin;
   selectedItem = CheckItemList( &hiliteR, x, y );


   /* initialize last click time */
   clickTime = (unsigned) opEvent.eventTime + dblClick;

    while( True ) {

      KeyEvent( True, &opEvent);

      /* check close box button or Escape key  */
      if( CheckClose( &viewDlgBox ) ) {
         selectedItem = -1;
         break;
      }

      /* return key = ok button */
      if( opEvent.eventChar == '\r' ) {
         OnButton( &viewDlgBox.OkR );
         break;
      }

      /* handle keyboard arrow keys */
      if( opEvent.eventChar == 0 || opEvent.eventChar == 0xE0 ) {


         /* up */
         if( opEvent.eventScan == 72 ) {
            opEvent.eventType = evntRELEASE;
            opEvent.eventX = viewSBar.upbox.Xmin;
            opEvent.eventY = viewSBar.upbox.Ymin;
            /* store a companion mouse up event */
            StoreEvent( &opEvent );
            /* make current event into a press event */
            opEvent.eventType = evntPRESS;
         }

         /* down */
         if( opEvent.eventScan == 80 ) {
	    opEvent.eventType = evntRELEASE;
            opEvent.eventX = viewSBar.dnbox.Xmin;
            opEvent.eventY = viewSBar.dnbox.Ymin;
            /* store a companion mouse up event */
            StoreEvent( &opEvent );
	    /* make current event into a press event */
            opEvent.eventType = evntPRESS;
         }

      }

      if( opEvent.eventType != evntPRESS )
         continue;

      x = opEvent.eventX;
      y = opEvent.eventY;

      /* check ok button */
      if( XYInRect( x, y, &viewDlgBox.OkR ) ) {
	 OnButton( &viewDlgBox.OkR );
         break;
      }
      if( XYInRect( x, y, &viewDlgBox.CanR ) ) {
	 OnButton( &viewDlgBox.CanR );
         break;
      }

      /* check scroll bar */
      if( XYInRect( x, y, &viewSBar.SBRect ) ) {

         /* unselect item */
         ProtectRect( &hiliteR );
         InvertRect( &hiliteR );
         hiliteR.Xmin =  -1;
         ProtectRect( NULL );

         DoScrollBar( &viewSBar );

	 /* reselect first item in list */
         x = viewDlgBox.BoxR.Xmin;
         y = viewDlgBox.BoxR.Ymin;
         selectedItem = CheckItemList( &hiliteR, x, y );

         continue;

      }


      /* check selection area */
      if( XYInRect( x, y, &viewDlgBox.BoxR ) ) {

         i = CheckItemList( &hiliteR, x,y );

         /* did they pick something ? */
         if( i != -1 ) {
      
            /* double click on same item ? */
	    if( i == selectedItem  &&
                ( (unsigned) opEvent.eventTime - clickTime ) < dblClick ) {
               OnButton( &viewDlgBox.OkR );
               break;

            }

            /* reset double click time */
            clickTime = (unsigned) opEvent.eventTime;

            selectedItem = i;

	 } /* end of picked something */

      } /* end of in selection area */


   }   /* end of while True */

   return  selectedItem;
}

int CheckItemList( rect *itemR, int x, int y )
/*
Figure out which line is selected by the x,y.
Returns the index of the selected item.
Returns -1 if no valid item selected.
Sets itemR to current highlighted item rectangle, or Xmin = -1  if none.
*/

{
   
   int i, charheight, pageworth, numleft;
   rect tR;

   DupRect( &viewDlgBox.BoxR, &tR );

   ProtectRect( &tR );

   /* re-invert the old selection if any */
   if( itemR->Xmin != -1 ) 
      InvertRect( itemR );

   /* find the new selection */
   charheight = scrnPort->txFont->lnSpacing;
   pageworth = (tR.Ymax - tR.Ymin) / charheight;
   numleft =  viewSBar.maxval - viewSBar.curval + 1;
   if( numleft < pageworth )
      pageworth = numleft;

   /* make a small rect one line deep */
   tR.Ymax = tR.Ymin + charheight;

   /* search for the line selected */

   for( i = 0; i < pageworth; i++ ) {
      if( XYInRect( x, y, &tR ) )
	 break;
      OffsetRect( &tR, 0, charheight );
   }
   if( i >= pageworth )  {
      /* outside of selectable items */
      itemR->Xmin = -1;
      ProtectRect(NULL);
      return -1;
   }

   /* save this as last item inverted */
   DupRect( &tR, itemR );

   InvertRect( itemR );

   ProtectRect(NULL);

   return (viewSBar.curval + i);

}



int GUIWindow( dialogBox *dia, char *name )
/*
Pops up a window with a title bar and close box.
A port is allocated and made active for the client area of the window.

*/
{
   rect tR;
   grafPort *wPort;
   pusharea savebuf;

   /* pop up a window  */
if(savewindow==True) OpenWindow( dia );

   DupRect( &(dia->BoundRect), &tR );

   ProtectRect( &tR );

   RasterOp( zREPz );
   BackColor( colors->bar );
   EraseRect( &tR );

   /* make a title bar */
   tR.Ymax = tR.Ymin + picY( 30 );
   PenColor( colors->low );
   MoveTo( tR.Xmin, tR.Ymax );   LineTo( tR.Xmax-1, tR.Ymax );
   PenColor( colors->high );
   MoveTo( tR.Xmin, tR.Ymax+1 ); LineTo( tR.Xmax-1, tR.Ymax+1 );

   TextAlign( alignCenter, alignMiddle );
   TextFace( cProportional );
   MoveTo( ( tR.Xmax + tR.Xmin ) / 2, ( tR.Ymax + tR.Ymin + 2 ) / 2 );
   PenColor( colors->text );
   DrawString( name );
   OnBevel( &(dia->BoundRect) );

   /* make a close box */
   tR.Xmax = tR.Xmin + picX( 30 );
   InsetRect( &tR, 4, 4 );
   OffsetRect( &tR, 2, 2 );
   PenColor( colors->high );
   MoveTo( tR.Xmin, tR.Ymax);
   LineTo( tR.Xmin, tR.Ymin);  LineTo( tR.Xmax, tR.Ymin);
   PenColor( colors->low );
   LineTo( tR.Xmax, tR.Ymax);  LineTo( tR.Xmin, tR.Ymax);
   DupRect( &tR, &dia->CanR );

   InsetRect( &tR, 3, 3 );
   PenColor( colors->high );
   MoveTo( tR.Xmin, tR.Ymax);
   LineTo( tR.Xmin, tR.Ymin);  LineTo( tR.Xmax, tR.Ymin);
   PenColor( colors->low );
   LineTo( tR.Xmax, tR.Ymax);  LineTo( tR.Xmin, tR.Ymax);
   PenColor( Black );
   

   /* build them a port */
   wPort = ( grafPort * ) malloc( sizeof( grafPort ) );
   if( wPort == NULL )
      return False;

   /* copy current port values to new port */
   PushGrafix( &savebuf );
   InitPort( wPort );
   PopGrafix( &savebuf );


   DupRect( &(dia->BoundRect), &tR );
   tR.Ymin += picY( 30 );
   InsetRect( &tR, 4, 4 );
   DupRect( &tR, &dia->BoxR );

   MovePortTo( tR.Xmin, tR.Ymin );
   PortSize( tR.Xmax - tR.Xmin, tR.Ymax - tR.Ymin );
   ClipRect( &(wPort->portRect) );   
   BackColor( White );
   EraseRect( &(wPort->portRect) );

   ProtectRect( NULL );

   return True;

}

int CheckClose( dialogBox *dia )
/*
Checks current event for GUI window close box hit
Returns True if it was
*/
{
   point closePt;

   /* exit on a ESC too */
   if( opEvent.eventChar == 0x1B )
      return True;

   /* mouse down ? */
   if( opEvent.eventType == evntPRESS )   {

      /* check close button */
      closePt.X = opEvent.eventX;
      closePt.Y = opEvent.eventY;
      Lcl2GblPt( &closePt );
      if( PtInRect( &closePt, &dia->CanR, 1,1 ) ) {
         return True;
      }
   }

   return False;

}


