/*  %kw # %v    %n    %d    %t # */
/* Version # 4    HELLO.C    18-Oct-93    15:05:58 # */

/******************************************************************/
/* HELLO.C - Generic GUI "Hello World" program                    */
/* This program is a "how to" sample program that can be used as  */
/* as template for any program using the Metagraphics GUI Toolkit */
/******************************************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <dos.h>
#include "metawndo.h"

#include "GUIconst.h"
#include "GUIextrn.h"
extern int mainstart;
extern image *holdImage;
int eject;
static palData RGBdata[256];

palData RGBColors[256];
extern  rect *scrnRect;
dialogBox mainDlgBox;
char * ViewList( char *fileName, char *wname );
void ViewFile( char *fileName, char *wname );

void WPGMenu(void);
void TiffMenu(void);
void BMPMenu(void);
void FileMenu( void );
void PcxMenu( void );
void GifMenu( void );
void PaletteMenu( void );
void AboutMenu( void );

int Tif_Save(char *filename,rect *R);
int view_PCX(void);
int Gif_Save(char *filename,rect *R);
int gifmain(void);
int BMP_Save(char *filename,rect *R);
int PCX_Save(char *filename,rect *R);
int BMPmain(void);
int WPG_Save(char *filename,rect *R);
int WPGmain(void);
int tifmain(void);


extern int writepal;
rect imagebox;

void Colorit(int);
void Button3D( rect *bR );

void Write_New_Palette(char *filebuf);
char Save_Pal[80];


menus  GUI_menu[] = {

/*-------------------------------------------------------------*/
/*--- Menu Bar Name -- Items -- Enables ---- Internal Use -----*/
/*-------------------------------------------------------------*/
     {
	{"&File"}, {     7}, {0xFF},  {0},{0,0,0,0},{0,0,0,0},
	{"&About","&Info","&Current Mode","Select &Video Mode", "&Quit","E&xit","&Stop"  },
     },
	 {
	{"P&alette"}, {   4}, {0xFF},  {0},{0,0,0,0},{0,0,0,0},
	{"&Load Palette ","&Write Palette","&Adjust Palette","PC&X Palette"},
     },

      {
	{"&TIF File"}, {   5}, {0xFF},  {0},{0,0,0,0},{0,0,0,0},
	{"&View TIF","&PCX->TIF ","&GIF->TIF","&BMP->TIF","&WPG->TIF"},
     },

	  {
	{"&PCX File"}, {   5}, {0xFF},  {0},{0,0,0,0},{0,0,0,0},
	{"&View PCX ","&TIF->PCX ","&GIF->PCX","&BMP->PCX","&WPG->PCX"},
     },
	  {
	{"&GIF File"}, {   5}, {0xFF},  {0},{0,0,0,0},{0,0,0,0},
	{"&View GIF","&PCX->GIF ","&TIF->GIF","&BMP->GIF","&WPG->GIF"},
     },

	 {
	{"&BMP File"}, {   5}, {0xFF},  {0},{0,0,0,0},{0,0,0,0},
	{"&View BMP","&PCX->BMP ","&TIF->BMP","&GIF->BMP","&WPG->BMP"},
     },
	 {
	{"&WPG File"}, {   5}, {0xFF},  {0},{0,0,0,0},{0,0,0,0},
      {"&View WPG","&PCX->WPG ","&TIF->WPG","&GIF->WPG","&BMP->WPG"},
     }


};

int numMenus = sizeof( GUI_menu ) / sizeof( menus );

/* menu codes */

#define MU_File         0
#define MI_About        0
#define MI_Info         1
#define MI_Current      2
#define MI_Select       3
#define MI_FileExit     4
#define MI_Quit         5
#define MI_Stop         6

#define MU_Palette      1
#define MI_Load         0
#define MI_Write        1
#define MI_Adjust       2
#define MI_PCX_Palette  3

#define MU_TIFF          2
#define MI_VTIF          0
#define MI_PCXt          1
#define MI_GIFt          2
#define MI_BMPt          3
#define MI_WPGt          4

#define MU_PCX          3
#define MI_VPCX         0
#define MI_TIFp         1
#define MI_GIFp         2
#define MI_BMPp         3
#define MI_WPGp         4

#define MU_GIF           4
#define MI_VGIF          0
#define MI_PCXg          1
#define MI_TIFg          2
#define MI_BMPg          3
#define MI_WPGg          4

#define MU_BMP           5
#define MI_VBMP          0
#define MI_PCXb          1
#define MI_TIFb          2
#define MI_GIFb          3
#define MI_WPGb          4

#define MU_WPG           6
#define MI_VWPG          0
#define MI_PCXw          1
#define MI_TIFw          2
#define MI_GIFw          3
#define MI_BMPw          4
void  Write_New_Palette(char *filebuf)
{
	 FILE *datafile;
	    int i;

	   if(( datafile=fopen(filebuf,"rb"))!=NULL) {

	for( i=0; i<256; i++ )
   {
      RGBdata[i].palRed   = getc(datafile);
	RGBdata[i].palGreen = getc(datafile);
	RGBdata[i].palBlue  = getc(datafile);

      /* scale from 8 to 16 bit values */
      RGBdata[i].palRed   *= 256;
      RGBdata[i].palGreen *= 256;
      RGBdata[i].palBlue  *= 256;
	}

   fclose( datafile );

      WritePalette( 0, 0,QueryColors() , RGBdata );


     }
}

void  Save_Palette(char *filebuf)
{
	 FILE *datafile;
	    int i;

	 ReadPalette( 0, 0,QueryColors() , RGBdata ); //save 16 or 256 colors

	   if(( datafile=fopen(filebuf,"wb"))!=NULL) {
	//save 16 or 256 colos
	//but write 256 colors in palette always
	//when program first starts guiinit.cpp will read in 256 colors
	//into RGBdata  even if in 16 color mode

	for( i=0; i<256; i++ )
   {

      fputc( RGBdata[i].palRed/256,   datafile );
      fputc( RGBdata[i].palGreen/256, datafile );
      fputc( RGBdata[i].palBlue/256,  datafile );


	}

   fclose( datafile );


     }
}




void screenXY(void)
{
 int start,x,y,i=0;
 point pointOld,pointA;

 int err=Dialog( diaAlert,"Set Two points with mouse for the ","area of the image to be saved ");
 if(err!=0){
 PenColor(15);
 while( True && i!=1) {

	start=0;

	KeyEvent( False, &opEvent );
	if( opEvent.eventChar == 0x1b ) break;

	x = opEvent.eventX;
	y = opEvent.eventY;

	  if( opEvent.eventType == evntPRESS )  {

	    pointA.X= x;
	    pointA.Y= y;

	    pointOld.X = 0;
	    pointOld.Y = 0;
	    start=1;


       }//end of mouse down




    if(start==1){
    while( True ) {
	 KeyEvent( False, &opEvent );
	x = opEvent.eventX;
	y = opEvent.eventY;
	if( opEvent.eventChar == 0x1b ){start=0; break;}

		  if( opEvent.eventType == evntPRESS )  {

	  HideCursor();
	  SetRect(&imagebox,pointA.X, pointA.Y,pointOld.X , pointOld.Y);
	  FrameRect(&imagebox);
	  SetRect(&imagebox,pointA.X, pointA.Y,x,y );
	   
	     //RasterOp( zREPz );
		//SetRect(&imagebox,pointA.X, pointA.Y,pointOld.X,pointOld.Y );
	    ShowCursor();
	     i=1;
	    break;

		}
	if( pointOld.X != x || pointOld.Y != y  ) {
	    HideCursor();
	    RasterOp( zXORz );
	    SetRect(&imagebox,pointA.X, pointA.Y,pointOld.X , pointOld.Y);
	    if(pointOld.X!=0 && pointOld.Y!=0)
	    FrameRect(&imagebox);

	    SetRect(&imagebox,pointA.X, pointA.Y,x,y );
	    FrameRect(&imagebox);
	    ShowCursor();

	    pointOld.X = x;
	    pointOld.Y = y;
	 }

    }


    }   //end of if start==1
    }
   InsetRect(&imagebox,2,2);
   }
   RasterOp( zREPz );

}

void AboutInit( void)
{


   /* display the about menu automatically */
  //opSelect.selItem = MI_About;
  //FileMenu();

}

 void Close()
{
   int i;
   char txt[80];
   switch(eject)
   {
   case 2:strcpy(txt,"Ok to quit?"); break;
   case 1:strcpy(txt,"Ok to Exit?"); break;
   case 3:strcpy(txt,"Ok to Stop?"); break;
   case 0:
   default:
   strcpy(txt,"Ok to quit?"); break;
   }
	i = Dialog( diaNull, txt, NULL );

   if( i != Ok ) {
	   opSelect.selectID = nullSelect;
	return;
   }

   /* tell GUI to exit */
   opSelect.selectID = exitSelect;

}

void ProcessMenu()
{
   switch( opSelect.selMenu) {

      case MU_File:
	 FileMenu();
	 break;


	case MU_TIFF:
	 TiffMenu();
	 break;
      case MU_PCX:
	 PcxMenu();
	 break;
	 case MU_Palette:
	 PaletteMenu();
	 break;

	case MU_GIF:
	 GifMenu();
	 break;
      case MU_BMP:
	 BMPMenu();
	 break;
	case MU_WPG:
	 WPGMenu();
	 break;

	/* add your menu cases here */

   }

}

void FileMenu()
{
    rect bR,icon1Rect,tR;
       char buf[80],buf1[80],buf2[80];
	 char *p;
       int i,charWid,x,y,line,err;
	  grafPort *wPort;


   switch( opSelect.selItem ) {
	case MI_Info:
	ViewFile("CONVERT.DOC", "Info" );
	GetPort( &wPort );
	SetPort( scrnPort );
	free( wPort );

	 break;

  case MI_About:


	GetPort(&wPort);


	 // make a dialog box
       line = scrnPort->txFont->lnSpacing;

	 /* center it */
	 x = scrnPort->portRect.Xmax / 2;
	 y = scrnPort->portRect.Ymax / 2;
	 i = scrnPort->portRect.Xmax/3;
	 SetRect( &bR, x - i, y - (8*line), x+i, y + (6*line ) );
	 ProtectRect( &bR );

	  PenColor( colors->bar );
	  FillRect(&bR,1);

	  OnBevel ( &bR );

		SetRect(&tR,bR.Xmin+15,bR.Ymin+15,bR.Xmin+200,bR.Ymin+225);

	 BackColor( colors->bar );
	 PenColor( colors->text );

	 TextMode( zREPz );
	 TextAlign( alignCenter, alignMiddle );
	   y = bR.Ymin+2*line;

		 MoveTo(bR.Xmin+((bR.Xmax-bR.Xmin)/2),y);
	 DrawString("META  CONVERTER" );


	  y = bR.Ymin+5*line;

	 MoveTo(x+100,y);
	 DrawString("Your Name Here" );
	 y += 2*line; MoveTo(x+100,y);
	 DrawString("Graphic File Converter");
	 y += 2*line; MoveTo(x+100,y);
	 DrawString("Version 1.0");


	 MoveTo(x,bR.Ymax-(2*line));
	 DrawString("Copyright (C) 1992 by Your Name Here.");

		 TextAlign( alignLeft, alignMiddle );

	 y = bR.Ymin+4*line;
	 MoveTo(bR.Xmin+20,y);
	 DrawString("Program developed from" );
	 y += 2*line; MoveTo(bR.Xmin+20,y);
	 DrawString("the book Bitmapped Graphics");
	 y += 2*line; MoveTo(bR.Xmin+20,y);
	 DrawString("Programming in C++");
	 y += 2*line; MoveTo(bR.Xmin+20,y);
	 DrawString("by Marv Luse");

	 /* wait a bit */
	 delay( 6500 );

	 /* fade out */

	 PenColor( Black );
	 RasterOp( zORz );
	 for( x = 1; x < 8; x++ ) {
	    PenPattern( x );
	    PaintRect( &bR );
		delay(2);
	 }
	 EraseRect( &bR );
	 PenPattern( 1 );
	 ProtectRect( NULL );

	 /* pop dialog off */

	  RegenDesk();
	 break;
	case MI_Quit:eject=1; Close(); break;
      case MI_Stop:eject=3; Close(); break;

	case MI_FileExit:eject=2; Close(); break;
	    case MI_Current:
      line= scrnPort->txFont->lnSpacing;

	 /* center it */
	x= scrnPort->portRect.Xmax / 2;
     y= scrnPort->portRect.Ymax / 2;
	 i = scrnPort->portRect.Xmax/4;
	 itoa(x+x,buf1,10);
	 itoa(y+y,buf2,10);

	 SetRect( &bR, x - i, y - (6*line), x+i, y + (6*line ) );
	 ProtectRect( &bR );

	  PenColor( colors->bar );
	  FillRect(&bR,1);

	  OnBevel ( &bR );

	 BackColor( colors->bar );
	 PenColor( colors->text );

	 TextMode( zREPz );
	 TextAlign( alignCenter, alignMiddle );

	 y -= 4*line;
	 MoveTo(x,y);
	 strcpy(buf,"Current Video Mode");
	 DrawString(buf );
	 y += 2*line; MoveTo(x,y);

	 strcpy(buf,"Screen Resoultion  ");
	 strcat(buf,buf1);
	 strcat(buf," X ");
	 strcat(buf,buf2);
	 DrawString(buf);
	  y += 2*line; MoveTo(x,y);

	  i = (int) QueryColors();
	 itoa(i+1,buf1,10);
	 strcpy(buf,"Number of colors  ");
	 strcat(buf,buf1);
	 DrawString(buf);
	 y += 2*line;
       i=y+ 2*line;
	charWid = scrnPort->txFont->chWidth;

   SetRect( &icon1Rect, x-(charWid*2),y,  x+(charWid*2),i);
   DrawButton( &icon1Rect,"OK" );
	KeyEvent( True, &opEvent );

    OnButton ( &icon1Rect );
	RegenDesk();
       break;
	case MI_Select:

      free( holdImage );
    mainstart=0;
   StopMouse();
   StopEvent();
   SetDisplay(TextPg0);
   StopGraphics();
   free( sysFont );
   InitGUI();
   InitMenu();
   InitDialog();
   mainstart=1;

    break;

      default:
      break;
    }
}

void PaletteMenu()

{
     rect wR,tR;
    grafPort *wPort;
     SetRect(&wR,0,barRect.Ymax+picY(5),scrnPort->portRect.Xmax,scrnPort->portRect.Ymax);

	FILE* f3;
	int i;
	char filebuf[40];
      char pcxfile[80];


   switch( opSelect.selItem ) {

      case MI_Load:

		strcpy( filebuf, "*.pal" );
	if ( Dialog( diaFile, "Palette files", filebuf ) == 0 ){

		return;
	    }
	  Write_New_Palette(filebuf);
	   if(( f3=fopen("SavePal.TXT","wb" ))!=NULL){
       strcpy(Save_Pal,filebuf);
    fwrite(Save_Pal, sizeof(Save_Pal), 1, f3);
    fclose(f3);
    }
	 break;


	case MI_Write:

    DupRect( &scrnPort->portRect, &wR );
    SetRect( &wR, picX( 50 ), wR.Ymin+picY( 100 ),wR.Xmax-picX( 50 ), wR.Ymax-picY( 50 ) );
	DupRect( &wR, &mainDlgBox.BoundRect );
     GUIWindow( &mainDlgBox, " Write New Palette Colors " );
	    Colorit(True);


    GetPort( &wPort );
    SetPort( scrnPort );

   free( wPort );

    RegenDesk();

	 break;
		case MI_Adjust:

    DupRect( &scrnPort->portRect, &wR );
    SetRect( &wR, picX( 50 ), wR.Ymin+picY( 100 ),wR.Xmax-picX( 50 ), wR.Ymax-picY( 50 ) );
	DupRect( &wR, &mainDlgBox.BoundRect );
     GUIWindow( &mainDlgBox, " Adjust Palette Colors " );
	    Colorit(False);


    GetPort( &wPort );
    SetPort( scrnPort );

   free( wPort );

    RegenDesk();

	 break;


	    case MI_PCX_Palette:
    i=  view_PCX();
    if(i==True) {
   strcpy( filebuf, "" );
    int   err= Dialog( diaChr, "Enter Palette file Name", filebuf );

	 if(err!=0){
	  char *p = strchr( filebuf, '.' );
	 if( p == 0 ) strcat( filebuf, ".pal" );
	  Save_Palette(filebuf);
	  }
    GetPort( &wPort );
    SetPort( scrnPort );
    free( wPort );

    InitMenu();
    RegenDesk();
    }

       break;



       default:
	    break;



    } // end of switch( opSelect.selItem )


}


void TiffMenu()
/*
Handle the View menu
*/
{

	char     pcxfile[80],*p;
	 ReadPalette( 0, 0,QueryColors() , RGBColors );
	 grafPort *wPort;
	 int err;
     switch( opSelect.selItem ) {

	case MI_PCXt:
	err=view_PCX();

	strcpy(pcxfile,"");
    if ( Dialog( diaChr, "Enter New TIF File Name", pcxfile ) == 0 ){
	 return;
	 }
	 p = strchr( pcxfile, '.' );
	 if( p == 0 ) strcat( pcxfile, ".tif" );
	   screenXY();
	  HideCursor();
     if(imagebox.Xmax>1 && imagebox.Ymax>1)  Tif_Save(pcxfile,&imagebox);
	  ShowCursor();
	 break;

	case MI_GIFt:
	err=gifmain();

	strcpy(pcxfile,"");
	if ( Dialog( diaChr, "Enter New TIF File Name", pcxfile ) == 0 ){
	return;
	}
	 p = strchr( pcxfile, '.' );
	 if( p == 0 ) strcat( pcxfile, ".tif" );
	  screenXY();
	  HideCursor();
	if(imagebox.Xmax>1 && imagebox.Ymax>1)  Tif_Save(pcxfile,&imagebox);
	  ShowCursor();

	    break;
	case MI_BMPt:
	   err=BMPmain();

	strcpy(pcxfile,"");
	if ( Dialog( diaChr, "Enter New TIF File Name", pcxfile ) == 0 ){
	return;
	 }
	 p = strchr( pcxfile, '.' );
	 if( p == 0 ) strcat( pcxfile, ".tif" );
	  screenXY();
	  HideCursor();
     if(imagebox.Xmax>1 && imagebox.Ymax>1)	  Tif_Save(pcxfile,&imagebox);
	  ShowCursor();

	   break;
	     case MI_WPGt:
	   err=WPGmain();

	strcpy(pcxfile,"");
	if ( Dialog( diaChr, "Enter New TIF File Name", pcxfile ) == 0 ){
	return;
	}
	 p = strchr( pcxfile, '.' );
	 if( p == 0 )strcat( pcxfile, ".tif" );
	  screenXY();
	  HideCursor();
     if(imagebox.Xmax>1 && imagebox.Ymax>1)	  Tif_Save(pcxfile,&imagebox);
	  ShowCursor();

	   break;

	case MI_VTIF:
	   err=tifmain();
	   KeyEvent( True, &opEvent );

	   break;

     default:
     return;


    }
	 if(err==1)
    {
     GetPort( &wPort );
   SetPort( scrnPort );
   free( wPort );
    }

    WritePalette( 0, 0,QueryColors() , RGBColors );

    InitMenu();
    RegenDesk();

}
void GifMenu()
/*
Handle the View menu
*/
{
	char     pcxfile[80],*p;
    ReadPalette( 0, 0,QueryColors() , RGBColors );
    int err;
    grafPort *wPort;
   switch( opSelect.selItem ) {

	case MI_PCXg:
	  err=view_PCX();

	strcpy(pcxfile,"");
	if ( Dialog( diaChr, "Enter New GIF File Name", pcxfile ) == 0 ){
	return;
	}
	 p = strchr( pcxfile, '.' );
	 if( p == 0 ) strcat( pcxfile, ".gif" );
	  screenXY();
	  HideCursor();
	if(imagebox.Xmax>1 && imagebox.Ymax>1)  Gif_Save(pcxfile,&imagebox);
	  ShowCursor();

	 break;

	case MI_TIFg:

	 err=tifmain();

	strcpy(pcxfile,"");
	if ( Dialog( diaChr, "Enter New GIF File Name", pcxfile ) == 0 ){
	return;
	 }
	  p = strchr( pcxfile, '.' );
	 if( p == 0 )strcat( pcxfile, ".gif" );
	  screenXY();
	  HideCursor();
	if(imagebox.Xmax>1 && imagebox.Ymax>1)  Gif_Save(pcxfile,&imagebox);
	  ShowCursor();
	  break;

	case MI_VGIF:
	err=gifmain();
	KeyEvent( True, &opEvent );

	   break;
	   case MI_BMPg:
	 err=BMPmain();

	strcpy(pcxfile,"");
     if ( Dialog( diaChr, "Enter New GIF File Name", pcxfile ) == 0 ){
     return;
     }
	 p = strchr( pcxfile, '.' );
	 if( p == 0 ) strcat( pcxfile, ".gif" );
	   screenXY();
	  HideCursor();
	if(imagebox.Xmax>1 && imagebox.Ymax>1)  Gif_Save(pcxfile,&imagebox);
	  ShowCursor();
	   break;

	   case MI_WPGg:
	 err=WPGmain();

	strcpy(pcxfile,"");
	if ( Dialog( diaChr, "Enter New GIF File Name", pcxfile ) == 0 ){
	return;
	}
	  p = strchr( pcxfile, '.' );
	 if( p == 0 ) strcat( pcxfile, ".gif" );
	   screenXY();
	  HideCursor();
	if(imagebox.Xmax>1 && imagebox.Ymax>1)  Gif_Save(pcxfile,&imagebox);
	  ShowCursor();


	    break;

     default:
     return;


    }
	if(err==1)
    {
     GetPort( &wPort );
   SetPort( scrnPort );
   free( wPort );
    }

   WritePalette( 0, 0,QueryColors() , RGBColors );

     InitMenu();
    RegenDesk();



}
void PcxMenu()
/*
Handle the View menu
*/
{

	char     pcxfile[80],*p;
    ReadPalette( 0, 0,QueryColors() , RGBColors );
   int err;
    grafPort *wPort;


   switch( opSelect.selItem ) {
    case MI_VPCX:
	 err=view_PCX();
	KeyEvent( True, &opEvent );

	break;
      case MI_TIFp:
		  err=tifmain();

	strcpy(pcxfile,"");
	if ( Dialog( diaChr, "Enter New PCX File Name", pcxfile ) == 0 ){
	return;
	 }


	  p = strchr( pcxfile, '.' );
	 if( p == 0 ) strcat( pcxfile, ".pcx" );
	   screenXY();
	  HideCursor();
	if(imagebox.Xmax>1 && imagebox.Ymax>1)  PCX_Save(pcxfile,&imagebox);
	  ShowCursor();
	   break;

      case MI_GIFp:
	  err=gifmain();

	strcpy(pcxfile,"");
	if ( Dialog( diaChr, "Enter New PCX File Name", pcxfile ) == 0 ){
	return;
	 }
	  p = strchr( pcxfile, '.' );
	 if( p == 0 ) strcat( pcxfile, ".pcx" );
	   screenXY();
	  HideCursor();
     if(imagebox.Xmax>1 && imagebox.Ymax>1)	  PCX_Save(pcxfile,&imagebox);
	  ShowCursor();
	  break;

	case MI_BMPp:
	 err=BMPmain();

	strcpy(pcxfile,"");
	if ( Dialog( diaChr, "Enter New PCX File Name", pcxfile ) == 0 ){
	return;
	 }
	  p = strchr( pcxfile, '.' );
	 if( p == 0 ) strcat( pcxfile, ".pcx" );
	  screenXY();
	  HideCursor();
	if(imagebox.Xmax>1 && imagebox.Ymax>1)  PCX_Save(pcxfile,&imagebox);
	  ShowCursor();
	  break;

	case MI_WPGp:
	 err=WPGmain();

	strcpy(pcxfile,"");
	if ( Dialog( diaChr, "Enter New PCX File Name", pcxfile ) == 0 ){
	return;
	 }
	  p = strchr( pcxfile, '.' );
	 if( p == 0 ) strcat( pcxfile, ".pcx" );
	  screenXY();
	  HideCursor();
	if(imagebox.Xmax>1 && imagebox.Ymax>1)  PCX_Save(pcxfile,&imagebox);
	  ShowCursor();
	  break;

     default:
     return;


    }
	 if(err==1)
    {
     GetPort( &wPort );
   SetPort( scrnPort );
   free( wPort );
    }

  WritePalette( 0, 0,QueryColors() , RGBColors );

    InitMenu();
    RegenDesk();


}
void BMPMenu()
/*
Handle the View menu
*/
{

	char     pcxfile[80],*p;
    ReadPalette( 0, 0,QueryColors() , RGBColors );
    int err;
    grafPort *wPort;
   switch( opSelect.selItem ) {

      case MI_VBMP:
	 err=BMPmain();
	 KeyEvent( True, &opEvent );

	break;
      case MI_PCXb:
			  err=view_PCX();

	strcpy(pcxfile,"");
	if ( Dialog( diaChr, "Enter New BMP File Name", pcxfile ) == 0 ){
	return;
	}
	  p = strchr( pcxfile, '.' );
	 if( p == 0 ) strcat( pcxfile, ".bmp" );
	    screenXY();
	  HideCursor();
	 if(imagebox.Xmax>1 && imagebox.Ymax>1) BMP_Save(pcxfile,&imagebox);
	  ShowCursor();
	  break;

      case MI_GIFb:
	    err=gifmain();

	strcpy(pcxfile,"");
	if ( Dialog( diaChr, "Enter New BMP File Name", pcxfile ) == 0 ){
	return;
	 }
	 p = strchr( pcxfile, '.' );
	 if( p == 0 ) strcat( pcxfile, ".bmp" );
	   screenXY();
	  HideCursor();
	 if(imagebox.Xmax>1 && imagebox.Ymax>1) BMP_Save(pcxfile,&imagebox);
	  ShowCursor();
	  break;

      case MI_TIFb:
	 err=tifmain();

	strcpy(pcxfile,"");
	if ( Dialog( diaChr, "Enter New BMP File Name", pcxfile ) == 0 ){
	return;
	 }
	  p = strchr( pcxfile, '.' );
	 if( p == 0 ) strcat( pcxfile, ".bmp" );
	  screenXY();
	  HideCursor();
	 if(imagebox.Xmax>1 && imagebox.Ymax>1) BMP_Save(pcxfile,&imagebox);
	  ShowCursor();
	   break;

	case MI_WPGb:
	 err=WPGmain();

	strcpy(pcxfile,"");
	if ( Dialog( diaChr, "Enter New BMP File Name", pcxfile ) == 0 ){
	return;
	 }
	  p = strchr( pcxfile, '.' );
	 if( p == 0 )strcat( pcxfile, ".bmp" );
	  screenXY();
	  HideCursor();
	 if(imagebox.Xmax>1 && imagebox.Ymax>1) BMP_Save(pcxfile,&imagebox);
	  ShowCursor();
	  break;


     default:
     return;


    }
     if(err==1)
    {
     GetPort( &wPort );
   SetPort( scrnPort );
   free( wPort );
    }

 WritePalette( 0, 0,QueryColors() , RGBColors );

    InitMenu();
    RegenDesk();


}

void WPGMenu()
/*
Handle the View menu
*/
{

	char     pcxfile[80],*p;
	 ReadPalette( 0, 0,QueryColors() , RGBColors );
	 int err;
	 grafPort *wPort;
     switch( opSelect.selItem ) {

	case MI_VWPG:
	 err=WPGmain();
	 KeyEvent( True, &opEvent );

	break;
	case MI_PCXw:
	 err=view_PCX();

	strcpy(pcxfile,"");
	if ( Dialog( diaChr, "Enter New WPG File Name", pcxfile ) == 0 ){
	return;
	}
	 p = strchr( pcxfile, '.' );
	 if( p == 0 ) strcat( pcxfile, ".wpg" );
	  screenXY();
	  HideCursor();
	 if(imagebox.Xmax>1 && imagebox.Ymax>1) WPG_Save(pcxfile,&imagebox);
	  ShowCursor();
	  break;

	case MI_GIFw:
	    err=gifmain();

	strcpy(pcxfile,"");
	if ( Dialog( diaChr, "Enter New WPG File Name", pcxfile ) == 0 ){
	return;
	 }
	 p = strchr( pcxfile, '.' );
	 if( p == 0 )strcat( pcxfile, ".wpg" );
	  screenXY();
	  HideCursor();
	 if(imagebox.Xmax>1 && imagebox.Ymax>1) WPG_Save(pcxfile,&imagebox);
	  ShowCursor();
	  break;

	case MI_TIFw:
	 err=tifmain();

	strcpy(pcxfile,"");
	if ( Dialog( diaChr, "Enter New WPG File Name", pcxfile ) == 0 ){
	return;
	}
	 p = strchr( pcxfile, '.' );
	 if( p == 0 ) strcat( pcxfile, ".wpg" );
	  screenXY();
	  HideCursor();
	 if(imagebox.Xmax>1 && imagebox.Ymax>1) WPG_Save(pcxfile,&imagebox);
	  ShowCursor();
	  break;

	     case MI_BMPw:
	 err=BMPmain();

	strcpy(pcxfile,"");
	if ( Dialog( diaChr, "Enter New WPG File Name", pcxfile ) == 0 ){
	return;
	 }
	  p = strchr( pcxfile, '.' );
	 if( p == 0 )strcat( pcxfile, ".wpg" );
	  screenXY();
	  HideCursor();
	 if(imagebox.Xmax>1 && imagebox.Ymax>1) WPG_Save(pcxfile,&imagebox);
	  ShowCursor();
	  break;

     default:
     return;


    }
    if(err==1)
    {
     GetPort( &wPort );
   SetPort( scrnPort );
   free( wPort );
    }
    WritePalette( 0, 0,QueryColors() , RGBColors );

    InitMenu();
    RegenDesk();


}

