#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include "metawndo.h"      /* master MetaWINDOW include file */
#include "GUIconst.h"
#include "GUIextrn.h"
#include "gif.hpp"
#include "gifcodec.hpp"
extern int meta_hd_size;
extern dialogBox mainDlgBox;
extern int *clrmap;
extern palData   PCXColors[256];
static   palData   RGBdata[256];
void Pal_Table(void);
static palData   golbalColors[256],localColors[256];
int gclpal,lclpal,pal,ngbl,nlcl;        // local palette
int Gif_Save(char *filename,rect *R);
int load_gif( char *fn,rect *wR );
int gifmain( void);

void show_core(char *txt);


void exit_pgm( char *msg )
{
	Dialog( diaAlert, "Error with File", msg );

}
int Gif_Save(char *filename,rect *R)

{
   //show_core("gif save start");
   rect sR;
   grafPort *wPort;
  image *pkPtr,*buf,*buf2,*scanln;
   int i,y;
   int j,pixx;
   int maxcolors=QueryColors()+1;

    GetPort(&wPort);
   DupRect( R, &sR );

   int nbits=8;//wPort->portMap->pixBits;
   int planes=1;//wPort->portMap->pixPlanes;


   int nrows   = sR.Ymax-sR.Ymin;
   int ncols   = sR.Xmax-sR.Xmin;
   nbits   = nbits * planes;
   int size    = (nbits < 8) ? nbits+1 : nbits;
   int ncolors = 256;//QueryColors() +1;


   scanln = (image *)malloc(ncols*5);
   if( scanln == NULL ) {
    Dialog( diaAlert, "Not enough memory!", "for scanline" );
   return 0;
   }
   buf = (image *)malloc(ncols*5);
   if( buf == NULL ) {
   free(scanln);
   Dialog( diaAlert, "Not enough memory!", "for buf" );
   return  0;
   }

   // open and write the file
   FILE *f = fopen( filename, "w+b" );

   // GIF header - since we don't employ any of the
   // 89a extensions we set the version to 87a
  fwrite( "GIF87a", 1, 6, f );


     // GIF screen descriptor
   GIFSCDESC scd( ncols, nrows, nbits );
   if( scd.put( f ) ) Dialog( diaAlert, "Error with File", "screen descriptor error" );//return xIOERROR;
	// the Global Color Table
    ReadPalette( 0, 0,QueryColors() , RGBdata );

	for( i=0; i<ncolors; i++ )
   {

	fputc((char) (RGBdata[i].palRed/256),f );
	fputc((char) (RGBdata[i].palGreen/256),f);
	fputc( (char)(RGBdata[i].palBlue/256), f);


	}

    // GIF image descriptor
   GIFIMDESC imd( ncols, nrows, nbits );
   if( imd.put( f ) ) Dialog( diaAlert, "Error with File", "image descriptor error" );//return xIOERROR;

   // min LZW code size
   fputc( size, f );

   // output the encoded bitmap
   GifEncoder enc( f, size );
   enc.init();
   y=sR.Ymin;

  if(maxcolors>16){ //256 color mode
   for( i=0; i<nrows; i++ )
   {
	 sR.Ymin = y+i;
	 sR.Ymax = y+i+1;
     ReadImage(&sR,scanln);

	for(j=0;j<ncols;j++)
	 buf[j]=scanln[j+meta_hd_size];  //minus imageHeader (12 bytes) for ReadImage buf record

	if( enc.encode( buf, ncols ) != xOKAY )
	{
	 Dialog( diaAlert, "Error with File", "encoder error" );
	 free(scanln);
	 free(buf);
	 fclose( f );
	 return enc.status();
	}
   }
  }//end of 256 color mode

     if(maxcolors<=16){

     if( ( pkPtr = (image *)( malloc( ncols*5 ) ) )  == NULL ){
     free(scanln);
     free(buf);
     fclose( f );
     return 0;
     }

    for( i=0; i<nrows; i++ )
   {
	 sR.Ymin = y+i;
	 sR.Ymax = y+i+1;

	ReadImage(&sR, pkPtr);
	XlateImage(pkPtr,buf,8,1,NULL);
	 for(j=0;j<ncols;j++)
	 scanln[j]=buf[j+meta_hd_size];  //minus imageHeader (12 bytes) for ReadImage buf record

	if( enc.encode( scanln, ncols ) != xOKAY )
	{
	  Dialog( diaAlert, "Error with File", "encoder error" );

	 free(pkPtr);
	 free(scanln);
	 free(buf);
	 fclose( f );
	 return 0;
	}
     }
   }

   enc.term();

   // output block terminator
   fputc( 0, f );

   // output trailer
   fputc( 0x3B, f );
   fclose( f );
   // finished

    if(maxcolors<=16)free(pkPtr);

   free(scanln);
   free(buf);
    //show_core("gif save end");

   return 1;
}

//..................skip data blocks

void skip_blocks( FILE *f )
{
   int nbytes;
   while( (nbytes=fgetc(f)) > 0 )
	fseek( f, nbytes, SEEK_CUR );
}

//..................determine interlaced row number

static int currow   = -8;
static int curpass  = 0;
static int delta[]  = { 8, 8, 4, 2 };
static int origin[] = { 0, 4, 2, 1 };

int row( int nrows )
{
   currow += delta[curpass];
   if( currow >= nrows )
   {
	curpass++;
	currow = origin[curpass];
   }
   return currow;
}

//..................process image description

void do_image( FILE *f,rect *wR)

 {

   grafPort *wPort;
   rect sR,box;
   int i,j,n,colortable=0,err,rwbytes;
   image *buf2,*pkPtr,*buf,*scanln;
   GIFIMDESC imd;
   imageHeader    *imPtr;
     meta_hd_size=(sizeof(imageHeader));

	currow   = -8;    //reset each time
	curpass  = 0;

   if( imd.get( f ) ){
	exit_pgm( "Error reading GIF image descriptor" );
	return;
	}

   if( imd.islct() )
   {
	nlcl = imd.ncolors();
	 for( i=0; i<nlcl; i++ )
	{
	localColors[i].palRed   = fgetc(f);
	localColors[i].palGreen = fgetc(f);
	localColors[i].palBlue  = fgetc(f);

	/* scale from 8 to 16 bit values */
	localColors[i].palRed   *= 256;
	localColors[i].palGreen *= 256;
	localColors[i].palBlue  *= 256;
	}
	 if( feof(f) || ferror(f) ){
	 exit_pgm( "Error reading local color table" );
	 }
	 lclpal=1;
   }
    //GIFSCDESC  pp;
   // create bitmap to be filled
   int ncols = imd.imwidth;
   int nrows = imd.imheight;
	rwbytes=ncols;

	if(ncols>1024){
	fclose(f);
	Dialog( diaAlert, "Not enough memory!", "for buf" );
	return;
   }
     scanln = (image *)malloc(ncols*5);
	if( scanln == NULL ) {
	Dialog( diaAlert, "Not enough memory!", "for scanline" );
	return;
	}
    buf = (image *)malloc(ncols*5);
    if( buf == NULL ) {
    free(scanln);
    Dialog( diaAlert, "Not enough memory!", "for buf" );
    return;
    }

     buf2 = (image *)malloc(ncols*5);

   if( ( pkPtr = (image  *)( malloc( rwbytes*5 )))  == NULL ){
	free(scanln);
	free(buf);
	free(buf2);
	return ;
	}
	 meta_hd_size=(sizeof(imageHeader));
	GetPort(&wPort);
     PenColor(0);

    if ( wR != NULL )  DupRect( wR, &box );


	if(wR==NULL)FillRect(&wPort->portRect,1);
	 else FillRect(&box,1);
     SetRect(&sR,0,0,ncols,1);
    ReadImage(&sR,buf);   //neeed ImageHearder Info
    //ReadImage(&sR,pkPtr);

   if(wR!=NULL){  //used to display image in box rect
   SetRect(&sR,box.Xmin,box.Ymin,box.Xmin+ncols,box.Ymin+1);
   }

     else{
     sR.Ymin +=10; //add 10 to display lower on screen
    	}



   // read min LZW code size
   int size = fgetc( f );

   GifDecoder dec( f, size,ncols);

   dec.init();


    int maxcolors=QueryColors()+1;

 if(gclpal==True)  WritePalette( 0, 0,ngbl-1 , golbalColors );
 if(lclpal==True) WritePalette( 0, 0,nlcl-1 , localColors );
 int ncolors=(ngbl>nlcl) ? ngbl : nlcl;

  if(maxcolors>16){  //256 color
	for(i=0; i<nrows; i++ )
	{
	dec.decode( scanln, ncols );
      n = imd.isinterlaced() ? row( nrows ) : i;

	for(j=0;j<ncols;j++)
	buf[j+meta_hd_size]=scanln[j];     //add imageHeader (12 bytes) for WriteImage buf record

	sR.Ymin = n;
	sR.Ymax = n+1;
	WriteImage(&sR,buf);
	}
   }//end of 256 color

 if(maxcolors<=16){
	if(ncolors>16) {
	     //ShowCursor();
	     ///err= Dialog( diaNull, "Convert 256 Color Graphic file ","to current video mode" );
	     //HideCursor();
	//if(err!=0)
	Pal_Table();colortable=1; //color table mapping
	 }

    // ReadImage(&sR,pkPtr);

   imPtr = (imageHeader *)pkPtr;       // pointer to MW image header
   imPtr->imWidth    = ncols;
   imPtr->imHeight   = 1;
   imPtr->imAlign    = 0;
   imPtr->imBits=8;
   imPtr->imPlanes=1;
   imPtr->imRowBytes=rwbytes; //can not be 24 bits per pixel for GIF


   for( i=0; i<nrows; i++ )
   {

	dec.decode( buf, ncols );
	n = imd.isinterlaced() ? row( nrows ) : i;
	 sR.Ymin = n;
	 sR.Ymax = n+1;


	   if(colortable==1){        //color mapping
	  for( j=0; j<ncols; j++ )
	  buf2[j] = clrmap[buf[j]];
	  for(j=0;j<ncols;j++)
	  pkPtr[j+meta_hd_size]=buf2[j];     //add imageHeader (12 bytes) for WriteImage buf record

     }

     else{     //no color mapping
	for(j=0;j<ncols;j++)
	 pkPtr[j+meta_hd_size]=buf[j];     //add imageHeader (12 bytes) for WriteImage buf record
	}
	memset(buf2,0x00,sizeof(buf2));
	XlateImage(pkPtr,buf2,1,4,NULL);
	WriteImage(&sR,buf2);



     }
   }//end of 16 color mode
     dec.term();


     free(buf2);
     free(pkPtr);
     free(scanln);
     free(buf);
     if(colortable==1) delete clrmap;

}

//..................process control extension

void do_ctl_ext( FILE *f )
{
   GIFCTLEXT ctl;
   if( ctl.get( f ) )
	exit_pgm( "Error reading GIF control extension" );
   skip_blocks( f );
}

//..................process comment extension

void do_com_ext( FILE *f )
{
   GIFCOMEXT com;
   if( com.get( f ) )
	exit_pgm( "Error reading GIF comment extension" );
   skip_blocks( f );
}

//..................process text extension

void do_txt_ext( FILE *f )
{
   GIFTXTEXT txt;
   if( txt.get( f ) )
	exit_pgm( "Error reading GIF text extension" );
   skip_blocks( f );
}

//..................process application extension

void do_app_ext( FILE *f )
{
   GIFAPPEXT app;
   if( app.get( f ) )
	exit_pgm( "Error reading GIF application extension" );
   skip_blocks( f );
}

//..................process extension

void do_extension( FILE *f )
{
   int label = fgetc( f );
   switch( label )
   {
	case 0xF9 : // control extension
	   do_ctl_ext( f );
	   break;

	case 0xFE : // comment extension
	   do_com_ext( f );
	   break;

	case 0x01 : // text extension
	   do_txt_ext( f );
	   break;

	case 0xFF : // application extension
	   do_app_ext( f );
	   break;

	default :   // unknown or invalid
	   if( label < 0 )
		printf( "Error reading extension\n" );
	   else
		printf( "Unknown or invalid extension %02Xh\n",
			 label );
	   exit( 0 );
	   break;
   }
}



int load_gif( char *fn,rect *wR )
{
   //show_core("load gif start");
   rgb *imgpal;

   int i;
   // open the file
   FILE *fgif = fopen( fn, "rb" );
     if( fgif == 0 ){     fclose(fgif);

		Dialog( diaAlert, "Gif file not found",NULL);
	return 0;
	}

   // read header
   GIFHEADER hdr;
   if( hdr.get( fgif ) )
	{    fclose(fgif);

			Dialog( diaAlert, "Error reading GIF header",NULL);
	return 0;
	}

   if( ! hdr.isvalid() )
	{     fclose(fgif);

			Dialog( diaAlert, "File is not a valid GIF file",NULL);
	return 0;
	}



   // read screen descriptor
   GIFSCDESC scd;
   if( scd.get( fgif ) )
		{    fclose(fgif);

			Dialog( diaAlert, "Error reading GIF screen descriptor",NULL);
	return 0;
	}
    int d=scd.depth();
     if( d==24 )
	{    fclose(fgif);
	 Dialog( diaAlert, "GIF file can not be","24 bits per pixel");
	 return 0;
	}



   // process global color table

   if( scd.isgct() )
   {
	 ngbl = scd.ncolors();
	imgpal = new rgb [ngbl];

	if( imgpal == 0 )
	{
	    return 0;
	}
	 for( int i=0; i<ngbl; i++ )
	{
	 int r = fgetc( fgif );
	 int g = fgetc( fgif );
	 int b = fgetc( fgif );
	 imgpal[i] = rgb( r, g, b );
	}

    for( i=0; i<ngbl; i++ )
   {
	golbalColors[i].palRed   = imgpal[i].red;
	golbalColors[i].palGreen = imgpal[i].grn;
	golbalColors[i].palBlue  = imgpal[i].blu;

	/* scale from 8 to 16 bit values */
	golbalColors[i].palRed   *= 256;
	golbalColors[i].palGreen *= 256;
	golbalColors[i].palBlue  *= 256;
    }

	    //use this for color mapping
   for( i=0; i<256; i++ )
   {
	    PCXColors[i].palRed = golbalColors[i].palRed;
	    PCXColors[i].palGreen = golbalColors[i].palGreen;
	    PCXColors[i].palBlue = golbalColors[i].palBlue;
   }

	 if( feof(fgif) || ferror(fgif) ){
	 exit_pgm( "Error reading global color table" );
	   fclose(fgif);
	 return 0;
	 }
     gclpal=True;
   }


   // scan for image
   int type;
   while( (type=fgetc(fgif)) > 0 )
   {
	if( type == 0x2C )       // image descriptor
	{
	 do_image( fgif ,wR);

	 break;
	}
	else if( type == 0x21 )  // extension
	 do_extension( fgif );
	else if( type == 0x3B )  // trailer
	 exit_pgm( "Unexpected GIF trailer" );
	else
	 exit_pgm( "Unknown or invalid construct" );
   }
    fclose(fgif);
    delete imgpal;
    //show_core("load gif end");
    return 1;
}

//..................Main

int gifmain( void)
{
	char     xfile[80];
	 rect wR;

	strcpy( xfile,"*.gif" );
	if ( Dialog( diaFile, "GIF files", xfile ) == 0 )
		return 0;

	 char *p = strchr( xfile, '.' );
	 if( p == 0 ) strcat( xfile, ".gif" );
    HideCursor();

    int err=load_gif(xfile,NULL );
    if(err==0){
    ShowCursor();
    return 0;
    }
    ShowCursor();
   return 1;
}
