/*  %kw # %v    %n    %d    %t #                    */
/*  Version # 3    COLORPAL.C    16-Jul-92    10:47:02 #    */
/* ************************************************ */
/*  METAGRAPHICS SOFTWARE CORPORATION (c) 1989-1992 */
/*  Demonstrates usage of Read/WritePalette         */
/* ************************************************ */

#include <stdlib.h>
#include <stddef.h>
#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <dos.h>
#include <ctype.h>
#include "metawndo.h"      /* master MetaWINDOW include file */

/* special stack size declaration if using Turbo or Borland C++ */
#ifdef      TurboC
extern unsigned _stklen = 14336U;  /* stack size 14K */
#endif


/* global variables */
int      GrafixCard,GrafixInput;

/* function prototypes */
void quit(char*, int );

void main( int argc, char *argv[] )
{
    int   i, c,cx, cy,maxx,maxy,bcolors;
   rect  scrnR;
   int a, j, x, y,size,ncolors;           /* size of square area to fill */


   /* init the system */
   MetQuery(argc,argv);      
   i = InitGraphics(GrafixCard);
   if( i != 0 )
      GrInitErr(i);   /* display reason for no go */   
    
   SetDisplay( GrafPg0 );
   ScreenRect( &scrnR );
    maxx=scrnR.Xmax;
    maxy=scrnR.Ymax;
    ncolors= QueryColors();
    bcolors=16;

   EraseRect( &scrnR );
	for (x = 0, i = maxx - 1; x < maxx; x++, i--)
    {   PenColor(x % bcolors);
	  MoveTo(x,0);LineTo(i,maxy);

    }

    for (y = 0, j = maxy - 1; y < maxy; y++, j--)
    {
    PenColor(y % bcolors);
    MoveTo(0,y);LineTo(maxx-1,j);

    }


    cx = maxx / 2;
    cy = maxy / 2;                /* find screen center */
    size = cy;                      /* fill half the screen */


    for (a = 0; a < 32765; a++)                /* main loop */
    {
	  if(kbhit())break;
	 for (x = a, i = 0;    /* scan a triangular slice of */
             i <= size;       /* the screen, pixel by pixel */
		 x += a, i++)
		{
	     if(kbhit())break;
/* Try changing x in the next line
   to (x << 4) or (x >> 4) for more patterns */

                for (y = x, j = i; j <= size; y += a, j++)
                {                          /* draw circles! */
			  c = (((long) x * x +
				(long) y * y) >> 10) % ncolors;

        /* Draw eight pie slices to fill a square region.
        * We can get away with this speed-up trick,
	  * since circles and squares have eight-way symettry */

			  {
			    PenColor(c);
			 SetPixel(cx + i, cy + j);
			 SetPixel(cx + j, cy + i);
			 SetPixel(cx + j, cy - i);
			 SetPixel(cx + i, cy - j);
			SetPixel(cx - i, cy - j);
			SetPixel(cx - j, cy - i);
			SetPixel(cx - j, cy + i);
			 SetPixel(cx - i, cy + j);
                    }
                }
            }
	  }


   quit("Normal End",0);
}


/*
** Standardized exit routine. Provides for a safe, orderly shutdown.
** Display a final msg, and returns the passed error code to DOS.
*/
void quit( char *msgptr, int err )
{
   int i;

   StopMouse();
   StopEvent();
   SetDisplay(TextPg0);
   if(err)
      putch(07);
   printf("\n\n%s",msgptr);
   i=QueryError();
   printf("\nQueryError=%d/%d",i >> 7,i & 127);
   if(err)
      i=err;
   StopGraphics();
   exit(i);
}

#include "metquery.c"


