

/*********************************************/
/*    Metagraphics Software Corporation      */
/*        Copyright (c) 1987-1990            */
/*********************************************/
/* FILE:    DMOCOLOR.C                       */
/* PURPOSE: allows palette changes           */
/*********************************************/
/*  %kw # %v    %n    %d    %t #             */
/* Version # 3    DMOCOLOR.C    12-Aug-92    14:35:04 # */
/*********************************************/
#include <string.h>
#include <fstream.h>
#include <stdio.h>
#include <stdlib.h>

#include "metawndo.h"
#include "GUIconst.h"
#include "GUIextrn.h"

static long     control[3];
static int      paltype;
static palData  palColors[1];
static int      max_colors;
static int      lnSpacing;
static rect     respalbox;
static int      respaldiag;

 int  CheckCloseBox(void);
static void draw_palette( void );
static int  check_palette( point * );
static void draw_clr_rect( int );
static void draw_panel( void );
static void draw_control( int );
static void draw_indicator( int );
static int  check_panel( point * );
static void mix_color( int );
static void unmix_color( int );
static void ColorMeGone(void);
int colorheart,tvcolor;
int speednumber;
extern int deskcolor;
int writepal;
char palfile[80];
void  Save_Palette(char *filebuf);
void GOnButton(rect *tR)
{
   grafPort *wPort;

  GetPort( &wPort );
    SetPort( scrnPort );
 OnButton ( tR );
     SetPort(wPort);
    //free( wPort );
}


int Colorit(int save)
{
   int        selPalEntry,heartc,x,y,ti;
   int        i, buttons, speed;
   rect       scrnR;
   point      cursor_pt;
   grafPort  *gp;
   int ret=0;

   HideCursor();
   BackColor(-1);
   SetRect( &scrnR, 0, 0, 1000, 1000 );
   VirtualRect( &scrnR );
   EraseRect( &scrnR );

   GetPort( &gp );
   cursor_pt.Y = gp->txFont->lnSpacing;
   Lcl2VirPt( &cursor_pt );
   lnSpacing = cursor_pt.Y;


   max_colors= QueryColors();

   paltype = 0;    /* Normal palette ops */

/* draw the palette */
   draw_palette();

/* draw the control panel */
   draw_panel();

/* draw palette reset box */
//   draw_ResetPaletteBox();
   rect okRect,cRect;
    SetRect(&okRect,200,900,275,980);
    SetRect(&cRect,325,900,450,980);
   BackColor(-1);
   DrawButton(&okRect,"OK");
   DrawButton(&cRect,"CANCEL");




/* start with palette entry 0 */
   selPalEntry = 0;
   unmix_color( selPalEntry );
   draw_indicator( 0 );
   draw_indicator( 1 );
   draw_indicator( 2 );
   draw_clr_rect( selPalEntry );

   speed= speednumber;   /* initialize the control speed */
/* process events */
   ShowCursor();
   ti=-10;
   while( True )
   {

	SetLocal();
	/* get an event & check close box */
	i = KeyEvent( False, &opEvent );
	if( CheckClose(&viewDlgBox) ){ret=0;break;}
	if( opEvent.eventChar == 0x1B ){ret=0; break;}
	 if( opEvent.eventChar == 0x0D ) { GOnButton(&okRect);ret=1;if(ti!=-10)colorheart=ti;break;}


	SetVirtual();

	/* convert event point to virtual */
      cursor_pt.X = opEvent.eventX;
	cursor_pt.Y = opEvent.eventY;
	Lcl2VirPt( &cursor_pt );
      x=opEvent.eventX = cursor_pt.X;
      y=opEvent.eventY = cursor_pt.Y;

	/* if we had a mouse press event */
	if( i && (opEvent.eventType & evntPRESS)  ) {


		/* clicked a palette box ? */
		i = check_palette( &cursor_pt );
		if( i >= 0 ) {
		/* select palette entry for editing */
		    selPalEntry = i;
                    ti=i;
		    unmix_color( selPalEntry );
                    draw_indicator( 0 );
		    draw_indicator( 1 );
		    draw_indicator( 2 );
		    draw_clr_rect( selPalEntry );


		    continue;
                }


		/* clicked a control ? */
		buttons = True;
		while( (i = check_panel( &cursor_pt ) ) >= 0 && buttons ) {


		    /* adjust selected control */
		    switch( i )
		    {
                        case 0: control[0]+=speed; i = 0; break;
			case 1: control[0]-=speed; i = 0; break;
			case 2: control[1]+=speed; i = 1; break;
			case 3: control[1]-=speed; i = 1; break;
			case 4: control[2]+=speed; i = 2; break;
                        case 5: control[2]-=speed; i = 2; break;
			default: i = 0; break;
		    }

                    /* move fast or slow */
		    //if(speed < 0x7FF)
			//speed+=0x3F;
		    //else
			//speed= 0x7FF;  /* fast slow move */

		     /* keep in range */
                    if( control[i] > 0xFFFFL )
			control[i] = 0xFFFFL;
		    if( control[i] < 0L )
			control[i] = 0L;

		    /* update control indicator */
		    draw_indicator( i );

                    /* update the palette */
		    mix_color( selPalEntry );

		    /* read current cursor position */
		    KeyEvent( False, &opEvent );

		    buttons = opEvent.eventButtons;

		    cursor_pt.X = opEvent.eventX;
		    cursor_pt.Y = opEvent.eventY;

		} /* end of while on a control */


	 /* which button pressed if any */
	if( XYInRect( x, y, &cRect )) {
	  ret=0;
	  GOnButton(&cRect);
	  break;
	}
		if( XYInRect( x, y, &okRect) ) {
	   if(ti!=-10)colorheart=ti;
	   tvcolor=ti;
	  ret=1;
	  GOnButton(&okRect);
	  break;
        }

      }  /* end of if mouse event */


    }  /* end of while( True ) */
       SetLocal();
	if((ret==1) && (save==True)){
       char buf1[80];

	strcpy(buf1,"");

	Dialog( diaChr, "Palette File", buf1 );

     char *p = strchr( buf1, '.' );
	 if( p == 0 )
	    strcat( buf1, ".pal" );
	Save_Palette(buf1);

      }
      return (ret);

     

}


void draw_palette(void)
/*
Draw a screen full of boxes, one for each color combination
*/
{
    int color;
    rect r;
    char buf[10];

    MoveTo( 0,0 );
    if(max_colors > 16)
    {
      SetRect( &r, 5, 5, 35, 45 );
      for( color = 0; color <= max_colors; color++ )
      {

	PenColor( color );
	PaintRect( &r );
	PenColor( Black );
	FrameRect( &r );

	OffsetRect( &r, 40, 0 );
	if( r.Xmax > 640 )
	{
	    r.Xmin = 5; r.Xmax = 35;
	    OffsetRect( &r, 0, 50 );
	}
      }
    }
    else
    {
      SetRect( &r, 5, 5, 105, 105 );

      for( color = 0; color <= max_colors; color++ )
      {

	PenColor( color );
	PaintRect( &r );
	PenColor( Black );
	FrameRect( &r );

	MoveTo( r.Xmin + 49, r.Ymax + 35 );
	sprintf( buf, "%d", color );
	DrawString( buf );

	OffsetRect( &r, 150, 0 );
	if( r.Xmax > 599 )
	{
	    r.Xmin = 5; r.Xmax = 105;
	    OffsetRect( &r, 0, 200 );
	}
      }
    }
}

int check_palette(point *thepoint)

/*
Check to see if thepoint is in one of the palette display boxes.
Returns the palette entry corresponding to that box, or -1 if not
in any box
*/
{
   int color;
   rect r;

   MoveTo( 0,0 );
   if(max_colors > 16)
   {
      SetRect( &r, 5, 5, 35, 45 );

      for( color = 0; color <=max_colors; color++ )
      {
	 if( PtInRect( thepoint,  &r, 1,1 ) )
	    return color;
	 OffsetRect( &r, 40, 0 );
	 if( r.Xmax > 640 )
	 {
	    r.Xmin = 5; r.Xmax = 35;
	    OffsetRect( &r, 0, 50 );
	 }
      }
   }
   else
   {
      SetRect( &r, 5, 5, 105, 105 );

      for( color = 0; color <=max_colors; color++ )
      {
	 if( PtInRect( thepoint,  &r, 1,1 ) )
	    return color;
	 OffsetRect( &r, 150, 0 );
	 if( r.Xmax > 599 )
	 {
	    r.Xmin = 5; r.Xmax = 105;
	    OffsetRect( &r, 0, 200 );
	 }
      }
   }
   return -1;
}

void draw_clr_rect( int palval )

/*
Fill the color mixing rectangle with color 'palval'
*/
{
    rect color_rect;
    char buf[40];

    SetRect( &color_rect, 0, 0, 100, 100 );
    OffsetRect( &color_rect, 725, 100 );
    PenColor( palval );
    ProtectRect( &color_rect );
    PaintRect( &color_rect );
    PenColor( Black );
    FrameRect( &color_rect );


    sprintf( buf,"%3d: %4X  %4X  %4X", palval, palColors[0].palRed,
    palColors[0].palGreen, palColors[0].palBlue);

    MoveTo( 810, 60 );
    DrawString( buf );
}


void draw_panel(void)
/*
Draw the control panel
*/
{

    PenColor( White );

    draw_control( 0 );
    draw_control( 1 );
    draw_control( 2 );
    draw_clr_rect( 0 );

}

void draw_control( int num )

{

    rect r;
    int i, x, y;
    char color;

    switch ( num ) {
	case 0: x = 670; color = 'R'; break;
	case 1: x = 770; color = 'G'; break;
	case 2: x = 870; color = 'B'; break;
	default: return;
    }

    y = 300;

    /* draw scale */
    PenColor( Black );
    MoveTo( x,y );
    LineRel( 0, 500 );

    MoveTo( x,y );
    LineTo( x - 20,y );

    MoveTo( x, y + 500 );
    LineTo( x - 20,y + 500 );

    for( i = y; i < (y + 500); i += 20 ) {
	MoveTo( x,i );
        LineTo( x - 10, i );
    }

    /* draw 'R' 'G' or 'B' */
    MoveTo( x, y - 30 );
    DrawChar( color );


    /* draw '+/-' control */
    y += 520;
    SetRect( &r, x - 30, y , x + 30, y + 80 );
    FrameRect( &r );
    MoveTo( x, y );
    LineTo( x, y + 80 );

    MoveTo( r.Xmin + 15, y + 40 );
    DrawChar( '+' );

    MoveTo( x + 15, y + 40 );
    DrawChar( '-' );

}

void draw_indicator( int num )
/*
Draw a thermometer type indicator bar for control 'num'
*/
{
    int x, y, i;
    rect r;

    x = 670 + 100 * num;
    y = 300;

    /* compute scale factor */
    i = (int) (control[num] / 131L);   /* 0xFFFF / 500 appx = 131 */

    /* fill on part */
    SetRect( &r, x + 1, y + 500 - i, x + 10, y + 500 );
    ProtectRect( &r );
    PaintRect( &r );
    ProtectRect( NULL );

    /* erase off part */
    SetRect( &r, x + 1, y, x + 10, y + 500 - i );
    ProtectRect( &r );
    EraseRect( &r );
    ProtectRect( NULL );
}

int   check_panel( point *thepoint )

/*
Check to see if thepoint is in one of the control knobs.
Returns knob number or -1 if not in any knob
*/
{
    int knob, x,y;
    rect r;

    y = 300 + 520;

    for( knob = 0; knob < 3; knob++ ) {

        x = 670 + 100 * knob;

	SetRect( &r, x - 30, y , x + 30, y + 80 );
        if( PtInRect( thepoint, &r, 1,1 ) ) {

            r.Xmin = (r.Xmax + r.Xmin) / 2;
            if( PtInRect( thepoint, &r, 1,1 ) )
                return (knob * 2 + 1);

	    return (knob * 2);
	}
    }

    return -1;
}


void mix_color( int palval )

/*
For color number entry 'palval' change color register entry
*/

{
    char buf[40];

    palColors[0].palRed   = (Word)control[0];
    palColors[0].palGreen = (Word)control[1];
    palColors[0].palBlue  = (Word)control[2];

    sprintf( buf,"%3d: %4X  %4X  %4X", palval, palColors[0].palRed,
     palColors[0].palGreen, palColors[0].palBlue);

    MoveTo( 810, 60 );
    DrawString( buf );
    WritePalette(paltype,palval,palval, &palColors[0]);
}

void  unmix_color( int palval )

/*
Get color value of palval and set controls
*/
{
   ReadPalette(paltype,palval,palval, &palColors[0]);
   control[0]= (long)palColors[0].palRed;
   control[1]= (long)palColors[0].palGreen;
   control[2]= (long)palColors[0].palBlue;


}




static void ColorMeGone(void)
{
   int        i, j, x, y;
   rect       r;
   grafPort  *gp;

   SetLocal();
   RasterOp( zREPz );
   PenColor( Black );
   BackColor( White );

   GetPort( &gp );
   DupRect( &gp->portRect, &r );
   ProtectRect( &r );
   EraseRect( &r );

   i = gp->txFont->lnSpacing;
   x = (r.Xmax - r.Xmin)/2 + r.Xmin;
   y = (r.Ymax - r.Ymin)/2 + r.Ymin;
   MoveTo( x, y - 2*i );
   DrawString( "SORRY," );
   MoveTo( x, y );
   DrawString( "THIS DEVICE DOES NOT SUPPORT" );
   MoveTo( x, y + 2*i );
   DrawString( "A CHANGABLE PALETTE" );

   j = StringWidth( "THIS DEVICE DOES NOT SUPPORT" )/2 + i*4;
   SetRect( &r, x - j, y - i*4, x + j, y + i*4 );
   for ( i=0 ; i < 3 ; i++ ) {
       FrameRect( &r );
       InsetRect( &r, 3, 3 );
   }

   ProtectRect( NULL );
   ShowCursor();

   /* loop until click in close box */
   for (;;) {
       (void)KeyEvent( True, &opEvent );
       if( CheckClose(&viewDlgBox) )
	   return;
   }
}

/* End Of File:  dmocolor.c */
